///File : main.hpp
//------------------------------------------------------------------------------
/*
    This file is part of Debtest.

    Debtest is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Debtest is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Debtest.  If not, see <http://www.gnu.org/licenses/>.
*/
//------------------------------------------------------------------------------
#if not defined MAIN_HPP_DEBTEST
#define MAIN_HPP_DEBTEST
//------------------------------------------------------------------------------
#define FILES_PER_CONTAINER 500
#define DEFAULT_THREAD_NB 2
//------------------------------------------------------------------------------
struct progressStr
{
    pthread_mutex_t mutex;
    float perCent;
    std::string msg;

    int verboseMode;
    bool isFilter;
    int nbThread;
};
//------------------------------------------------------------------------------
struct threadDataStr
{
    // Shared and protected by the mutex
    pthread_mutex_t mutex;
    int lastContainerId;

    // Thread data
    std::vector<std::vector<std::string> > allFilesList;
    std::vector<std::string> pkgFilesList;

    // Progress
    progressStr *progress;
};
//------------------------------------------------------------------------------
// Tread
void *threadSearch(void *data);
int threadGetNewContainer(threadDataStr &threadData);
//------------------------------------------------------------------------------
void filterResults(std::vector<std::vector<std::string> > &allFilesList, progressStr &progress);
void getAllFilesList(std::vector<std::vector<std::string> > &allFilesList, const std::vector<std::string> &excludePathList);
void getPkgFilesList(std::vector<std::string> &pkgFilesList, progressStr &progress);
void cmpFilesList(threadDataStr &threadData);

int getCoreNb();

// Table
void getCoords(const std::vector<std::vector<std::string> > &allFilesList, const size_t &id, size_t &i, size_t &j);

#endif // MAIN_HPP_DEBTEST
